# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Classes

#### Public Classes

* [`slurm`](#slurm): Manage SLURM

#### Private Classes

* `slurm::client`
* `slurm::common::config`
* `slurm::common::install`
* `slurm::common::install::apt`
* `slurm::common::install::rpm`
* `slurm::common::install::source`
* `slurm::common::munge`
* `slurm::common::setup`
* `slurm::common::user`
* `slurm::params`
* `slurm::resources`: Manage SLURM resources using Puppet types
* `slurm::slurmctld`
* `slurm::slurmctld::config`
* `slurm::slurmctld::service`
* `slurm::slurmd`
* `slurm::slurmd::config`
* `slurm::slurmd::service`
* `slurm::slurmdbd`
* `slurm::slurmdbd::config`
* `slurm::slurmdbd::db`
* `slurm::slurmdbd::service`
* `slurm::slurmrestd`
* `slurm::slurmrestd::service`

### Defined types

* [`slurm::conf`](#slurm--conf): Manage Slurm main configuration
* [`slurm::down_node`](#slurm--down_node): Manage SLURM down node configuration
* [`slurm::gres`](#slurm--gres): Manage SLURM GRES configuration
* [`slurm::job_container`](#slurm--job_container): Manage SLURM job_container.conf entry
* [`slurm::node`](#slurm--node): Manage SLURM node configuration
* [`slurm::nodeset`](#slurm--nodeset): Manage SLURM nodeset configuration
* [`slurm::partition`](#slurm--partition): Manage a SLURM partition configuration
* [`slurm::spank`](#slurm--spank): Manage SLURM SPANK plugin
* [`slurm::switch`](#slurm--switch): Add switch to topology.conf

### Data types

* [`Slurm::CPUBind`](#Slurm--CPUBind): Type for CPU bind settings
* [`Slurm::DownNodeState`](#Slurm--DownNodeState)
* [`Slurm::NodeState`](#Slurm--NodeState)
* [`Slurm::PartitionState`](#Slurm--PartitionState)
* [`Slurm::PreemptMode`](#Slurm--PreemptMode)
* [`Slurm::SelectTypeParameters`](#Slurm--SelectTypeParameters)
* [`Slurm::YesNo`](#Slurm--YesNo)

### Tasks

* [`reconfig`](#reconfig): Execute 'scontrol reconfig'

## Classes

### <a name="slurm"></a>`slurm`

Roles

#### Parameters

The following parameters are available in the `slurm` class:

* [`slurmd`](#-slurm--slurmd)
* [`slurmctld`](#-slurm--slurmctld)
* [`slurmdbd`](#-slurm--slurmdbd)
* [`database`](#-slurm--database)
* [`client`](#-slurm--client)
* [`slurmrestd`](#-slurm--slurmrestd)
* [`repo_baseurl`](#-slurm--repo_baseurl)
* [`install_method`](#-slurm--install_method)
* [`install_prefix`](#-slurm--install_prefix)
* [`package_ensure`](#-slurm--package_ensure)
* [`install_torque_wrapper`](#-slurm--install_torque_wrapper)
* [`install_pam`](#-slurm--install_pam)
* [`version`](#-slurm--version)
* [`source_dependencies`](#-slurm--source_dependencies)
* [`configure_flags`](#-slurm--configure_flags)
* [`source_install_manage_alternatives`](#-slurm--source_install_manage_alternatives)
* [`slurmd_service_ensure`](#-slurm--slurmd_service_ensure)
* [`slurmd_service_enable`](#-slurm--slurmd_service_enable)
* [`slurmd_service_limits`](#-slurm--slurmd_service_limits)
* [`slurmd_options`](#-slurm--slurmd_options)
* [`slurmctld_service_ensure`](#-slurm--slurmctld_service_ensure)
* [`slurmctld_service_enable`](#-slurm--slurmctld_service_enable)
* [`slurmctld_service_limits`](#-slurm--slurmctld_service_limits)
* [`slurmctld_options`](#-slurm--slurmctld_options)
* [`slurmdbd_service_ensure`](#-slurm--slurmdbd_service_ensure)
* [`slurmdbd_service_enable`](#-slurm--slurmdbd_service_enable)
* [`slurmdbd_service_limits`](#-slurm--slurmdbd_service_limits)
* [`slurmdbd_options`](#-slurm--slurmdbd_options)
* [`slurmctld_restart_on_failure`](#-slurm--slurmctld_restart_on_failure)
* [`slurmdbd_restart_on_failure`](#-slurm--slurmdbd_restart_on_failure)
* [`reload_services`](#-slurm--reload_services)
* [`restart_services`](#-slurm--restart_services)
* [`slurmctld_conn_validator_timeout`](#-slurm--slurmctld_conn_validator_timeout)
* [`reconfig_ignore_errors`](#-slurm--reconfig_ignore_errors)
* [`manage_slurm_user`](#-slurm--manage_slurm_user)
* [`slurm_user_group`](#-slurm--slurm_user_group)
* [`slurm_group_gid`](#-slurm--slurm_group_gid)
* [`slurm_user`](#-slurm--slurm_user)
* [`slurm_user_uid`](#-slurm--slurm_user_uid)
* [`slurm_user_comment`](#-slurm--slurm_user_comment)
* [`slurm_user_home`](#-slurm--slurm_user_home)
* [`slurm_user_managehome`](#-slurm--slurm_user_managehome)
* [`slurm_user_shell`](#-slurm--slurm_user_shell)
* [`slurmd_user`](#-slurm--slurmd_user)
* [`slurmd_user_group`](#-slurm--slurmd_user_group)
* [`manage_munge`](#-slurm--manage_munge)
* [`munge_key_source`](#-slurm--munge_key_source)
* [`munge_key_content`](#-slurm--munge_key_content)
* [`manage_slurm_conf`](#-slurm--manage_slurm_conf)
* [`manage_scripts`](#-slurm--manage_scripts)
* [`manage_firewall`](#-slurm--manage_firewall)
* [`use_syslog`](#-slurm--use_syslog)
* [`manage_logrotate`](#-slurm--manage_logrotate)
* [`logrotate_syslog_pid_path`](#-slurm--logrotate_syslog_pid_path)
* [`manage_rsyslog`](#-slurm--manage_rsyslog)
* [`manage_database`](#-slurm--manage_database)
* [`export_database`](#-slurm--export_database)
* [`export_database_tag`](#-slurm--export_database_tag)
* [`cli_filter_lua_source`](#-slurm--cli_filter_lua_source)
* [`cli_filter_lua_content`](#-slurm--cli_filter_lua_content)
* [`scrun_lua_source`](#-slurm--scrun_lua_source)
* [`scrun_lua_content`](#-slurm--scrun_lua_content)
* [`state_dir_nfs_device`](#-slurm--state_dir_nfs_device)
* [`state_dir_nfs_options`](#-slurm--state_dir_nfs_options)
* [`job_submit_lua_source`](#-slurm--job_submit_lua_source)
* [`job_submit_lua_content`](#-slurm--job_submit_lua_content)
* [`cluster_name`](#-slurm--cluster_name)
* [`slurmctld_host`](#-slurm--slurmctld_host)
* [`slurmdbd_host`](#-slurm--slurmdbd_host)
* [`conf_dir`](#-slurm--conf_dir)
* [`log_dir`](#-slurm--log_dir)
* [`env_dir`](#-slurm--env_dir)
* [`spank_plugins`](#-slurm--spank_plugins)
* [`enable_configless`](#-slurm--enable_configless)
* [`configless`](#-slurm--configless)
* [`conf_server`](#-slurm--conf_server)
* [`slurm_conf_override`](#-slurm--slurm_conf_override)
* [`slurm_conf_template`](#-slurm--slurm_conf_template)
* [`slurm_conf_source`](#-slurm--slurm_conf_source)
* [`partition_template`](#-slurm--partition_template)
* [`partition_source`](#-slurm--partition_source)
* [`node_template`](#-slurm--node_template)
* [`node_source`](#-slurm--node_source)
* [`switch_template`](#-slurm--switch_template)
* [`topology_source`](#-slurm--topology_source)
* [`gres_template`](#-slurm--gres_template)
* [`gres_source`](#-slurm--gres_source)
* [`partitions`](#-slurm--partitions)
* [`nodes`](#-slurm--nodes)
* [`nodesets`](#-slurm--nodesets)
* [`switches`](#-slurm--switches)
* [`greses`](#-slurm--greses)
* [`job_containers`](#-slurm--job_containers)
* [`slurmd_log_file`](#-slurm--slurmd_log_file)
* [`slurmd_spool_dir`](#-slurm--slurmd_spool_dir)
* [`slurmctld_log_file`](#-slurm--slurmctld_log_file)
* [`state_save_location`](#-slurm--state_save_location)
* [`slurmdbd_archive_dir`](#-slurm--slurmdbd_archive_dir)
* [`slurmdbd_log_file`](#-slurm--slurmdbd_log_file)
* [`slurmdbd_storage_host`](#-slurm--slurmdbd_storage_host)
* [`slurmdbd_storage_loc`](#-slurm--slurmdbd_storage_loc)
* [`slurmdbd_storage_pass`](#-slurm--slurmdbd_storage_pass)
* [`slurmdbd_storage_port`](#-slurm--slurmdbd_storage_port)
* [`slurmdbd_storage_type`](#-slurm--slurmdbd_storage_type)
* [`slurmdbd_storage_user`](#-slurm--slurmdbd_storage_user)
* [`slurmdbd_db_charset`](#-slurm--slurmdbd_db_charset)
* [`slurmdbd_db_collate`](#-slurm--slurmdbd_db_collate)
* [`slurmdbd_conf_override`](#-slurm--slurmdbd_conf_override)
* [`slurmdbd_archive_dir_nfs_device`](#-slurm--slurmdbd_archive_dir_nfs_device)
* [`slurmdbd_archive_dir_nfs_options`](#-slurm--slurmdbd_archive_dir_nfs_options)
* [`use_nhc`](#-slurm--use_nhc)
* [`include_nhc`](#-slurm--include_nhc)
* [`health_check_program`](#-slurm--health_check_program)
* [`health_check_program_source`](#-slurm--health_check_program_source)
* [`manage_epilog`](#-slurm--manage_epilog)
* [`epilog`](#-slurm--epilog)
* [`epilog_source`](#-slurm--epilog_source)
* [`epilog_sourceselect`](#-slurm--epilog_sourceselect)
* [`manage_prolog`](#-slurm--manage_prolog)
* [`prolog`](#-slurm--prolog)
* [`prolog_source`](#-slurm--prolog_source)
* [`prolog_sourceselect`](#-slurm--prolog_sourceselect)
* [`manage_task_epilog`](#-slurm--manage_task_epilog)
* [`task_epilog`](#-slurm--task_epilog)
* [`task_epilog_source`](#-slurm--task_epilog_source)
* [`manage_task_prolog`](#-slurm--manage_task_prolog)
* [`task_prolog`](#-slurm--task_prolog)
* [`task_prolog_source`](#-slurm--task_prolog_source)
* [`auth_alt_types`](#-slurm--auth_alt_types)
* [`jwt_key_content`](#-slurm--jwt_key_content)
* [`jwt_key_source`](#-slurm--jwt_key_source)
* [`slurmrestd_listen_address`](#-slurm--slurmrestd_listen_address)
* [`slurmrestd_disable_token_creation`](#-slurm--slurmrestd_disable_token_creation)
* [`slurmrestd_user`](#-slurm--slurmrestd_user)
* [`slurmrestd_user_group`](#-slurm--slurmrestd_user_group)
* [`slurmrestd_service_ensure`](#-slurm--slurmrestd_service_ensure)
* [`slurmrestd_service_enable`](#-slurm--slurmrestd_service_enable)
* [`slurmrestd_service_limits`](#-slurm--slurmrestd_service_limits)
* [`slurmrestd_options`](#-slurm--slurmrestd_options)
* [`slurmrestd_restart_on_failure`](#-slurm--slurmrestd_restart_on_failure)
* [`cgroup_conf_template`](#-slurm--cgroup_conf_template)
* [`cgroup_conf_source`](#-slurm--cgroup_conf_source)
* [`cgroup_mountpoint`](#-slurm--cgroup_mountpoint)
* [`cgroup_plugin`](#-slurm--cgroup_plugin)
* [`cgroup_allowed_ram_space`](#-slurm--cgroup_allowed_ram_space)
* [`cgroup_allowed_swap_space`](#-slurm--cgroup_allowed_swap_space)
* [`cgroup_constrain_cores`](#-slurm--cgroup_constrain_cores)
* [`cgroup_constrain_devices`](#-slurm--cgroup_constrain_devices)
* [`cgroup_constrain_ram_space`](#-slurm--cgroup_constrain_ram_space)
* [`cgroup_constrain_swap_space`](#-slurm--cgroup_constrain_swap_space)
* [`cgroup_max_ram_percent`](#-slurm--cgroup_max_ram_percent)
* [`cgroup_max_swap_percent`](#-slurm--cgroup_max_swap_percent)
* [`cgroup_memory_swappiness`](#-slurm--cgroup_memory_swappiness)
* [`cgroup_min_ram_space`](#-slurm--cgroup_min_ram_space)
* [`cgroup_signal_child_processes`](#-slurm--cgroup_signal_child_processes)
* [`oci_conf_template`](#-slurm--oci_conf_template)
* [`oci_conf_source`](#-slurm--oci_conf_source)
* [`oci_container_path`](#-slurm--oci_container_path)
* [`oci_create_env_file`](#-slurm--oci_create_env_file)
* [`oci_debug_flags`](#-slurm--oci_debug_flags)
* [`oci_disable_cleanup`](#-slurm--oci_disable_cleanup)
* [`oci_disable_hooks`](#-slurm--oci_disable_hooks)
* [`oci_env_exclude`](#-slurm--oci_env_exclude)
* [`oci_mount_spool_dir`](#-slurm--oci_mount_spool_dir)
* [`oci_run_time_env_exclude`](#-slurm--oci_run_time_env_exclude)
* [`oci_file_debug`](#-slurm--oci_file_debug)
* [`oci_ignore_file_config_json`](#-slurm--oci_ignore_file_config_json)
* [`oci_run_time_create`](#-slurm--oci_run_time_create)
* [`oci_run_time_delete`](#-slurm--oci_run_time_delete)
* [`oci_run_time_kill`](#-slurm--oci_run_time_kill)
* [`oci_run_time_query`](#-slurm--oci_run_time_query)
* [`oci_run_time_run`](#-slurm--oci_run_time_run)
* [`oci_run_time_start`](#-slurm--oci_run_time_start)
* [`oci_srun_path`](#-slurm--oci_srun_path)
* [`oci_srun_args`](#-slurm--oci_srun_args)
* [`oci_std_io_debug`](#-slurm--oci_std_io_debug)
* [`oci_syslog_debug`](#-slurm--oci_syslog_debug)
* [`slurm_sh_template`](#-slurm--slurm_sh_template)
* [`slurm_csh_template`](#-slurm--slurm_csh_template)
* [`profile_d_env_vars`](#-slurm--profile_d_env_vars)
* [`slurmd_port`](#-slurm--slurmd_port)
* [`slurmctld_port`](#-slurm--slurmctld_port)
* [`slurmdbd_port`](#-slurm--slurmdbd_port)
* [`slurmrestd_port`](#-slurm--slurmrestd_port)
* [`tuning_net_core_somaxconn`](#-slurm--tuning_net_core_somaxconn)
* [`include_resources`](#-slurm--include_resources)
* [`clusters`](#-slurm--clusters)
* [`qoses`](#-slurm--qoses)
* [`reservations`](#-slurm--reservations)
* [`accounts`](#-slurm--accounts)
* [`users`](#-slurm--users)
* [`licenses`](#-slurm--licenses)
* [`purge_qos`](#-slurm--purge_qos)
* [`slurmdbd_conn_validator_timeout`](#-slurm--slurmdbd_conn_validator_timeout)

##### <a name="-slurm--slurmd"></a>`slurmd`

Data type: `Boolean`



Default value: `false`

##### <a name="-slurm--slurmctld"></a>`slurmctld`

Data type: `Boolean`



Default value: `false`

##### <a name="-slurm--slurmdbd"></a>`slurmdbd`

Data type: `Boolean`



Default value: `false`

##### <a name="-slurm--database"></a>`database`

Data type: `Boolean`



Default value: `false`

##### <a name="-slurm--client"></a>`client`

Data type: `Boolean`



Default value: `true`

##### <a name="-slurm--slurmrestd"></a>`slurmrestd`

Data type: `Boolean`



Default value: `false`

##### <a name="-slurm--repo_baseurl"></a>`repo_baseurl`

Data type: `Optional[Variant[Stdlib::HTTPSUrl, Stdlib::HTTPUrl, Pattern[/^file:\/\//]]]`



Default value: `undef`

##### <a name="-slurm--install_method"></a>`install_method`

Data type: `Optional[Enum['package','source','none']]`



Default value: `undef`

##### <a name="-slurm--install_prefix"></a>`install_prefix`

Data type: `Stdlib::Absolutepath`



Default value: `'/usr'`

##### <a name="-slurm--package_ensure"></a>`package_ensure`

Data type: `String`



Default value: `'present'`

##### <a name="-slurm--install_torque_wrapper"></a>`install_torque_wrapper`

Data type: `Boolean`



Default value: `false`

##### <a name="-slurm--install_pam"></a>`install_pam`

Data type: `Boolean`



Default value: `true`

##### <a name="-slurm--version"></a>`version`

Data type: `String`



Default value: `'23.11.5'`

##### <a name="-slurm--source_dependencies"></a>`source_dependencies`

Data type: `Array`



Default value: `[]`

##### <a name="-slurm--configure_flags"></a>`configure_flags`

Data type: `Array`



Default value: `[]`

##### <a name="-slurm--source_install_manage_alternatives"></a>`source_install_manage_alternatives`

Data type: `Boolean`



Default value: `true`

##### <a name="-slurm--slurmd_service_ensure"></a>`slurmd_service_ensure`

Data type: `Enum['running','stopped']`



Default value: `'running'`

##### <a name="-slurm--slurmd_service_enable"></a>`slurmd_service_enable`

Data type: `Boolean`



Default value: `true`

##### <a name="-slurm--slurmd_service_limits"></a>`slurmd_service_limits`

Data type: `Hash`



Default value: `{}`

##### <a name="-slurm--slurmd_options"></a>`slurmd_options`

Data type: `Optional[String[1]]`



Default value: `undef`

##### <a name="-slurm--slurmctld_service_ensure"></a>`slurmctld_service_ensure`

Data type: `Enum['running','stopped']`



Default value: `'running'`

##### <a name="-slurm--slurmctld_service_enable"></a>`slurmctld_service_enable`

Data type: `Boolean`



Default value: `true`

##### <a name="-slurm--slurmctld_service_limits"></a>`slurmctld_service_limits`

Data type: `Hash`



Default value: `{}`

##### <a name="-slurm--slurmctld_options"></a>`slurmctld_options`

Data type: `Optional[String[1]]`



Default value: `undef`

##### <a name="-slurm--slurmdbd_service_ensure"></a>`slurmdbd_service_ensure`

Data type: `Enum['running','stopped']`



Default value: `'running'`

##### <a name="-slurm--slurmdbd_service_enable"></a>`slurmdbd_service_enable`

Data type: `Boolean`



Default value: `true`

##### <a name="-slurm--slurmdbd_service_limits"></a>`slurmdbd_service_limits`

Data type: `Hash`



Default value: `{}`

##### <a name="-slurm--slurmdbd_options"></a>`slurmdbd_options`

Data type: `Optional[String[1]]`



Default value: `undef`

##### <a name="-slurm--slurmctld_restart_on_failure"></a>`slurmctld_restart_on_failure`

Data type: `Boolean`



Default value: `true`

##### <a name="-slurm--slurmdbd_restart_on_failure"></a>`slurmdbd_restart_on_failure`

Data type: `Boolean`



Default value: `true`

##### <a name="-slurm--reload_services"></a>`reload_services`

Data type: `Boolean`



Default value: `false`

##### <a name="-slurm--restart_services"></a>`restart_services`

Data type: `Boolean`



Default value: `true`

##### <a name="-slurm--slurmctld_conn_validator_timeout"></a>`slurmctld_conn_validator_timeout`

Data type: `Integer`



Default value: `60`

##### <a name="-slurm--reconfig_ignore_errors"></a>`reconfig_ignore_errors`

Data type: `Boolean`



Default value: `false`

##### <a name="-slurm--manage_slurm_user"></a>`manage_slurm_user`

Data type: `Boolean`



Default value: `true`

##### <a name="-slurm--slurm_user_group"></a>`slurm_user_group`

Data type: `String[1]`



Default value: `'slurm'`

##### <a name="-slurm--slurm_group_gid"></a>`slurm_group_gid`

Data type: `Optional[Integer]`



Default value: `undef`

##### <a name="-slurm--slurm_user"></a>`slurm_user`

Data type: `String[1]`



Default value: `'slurm'`

##### <a name="-slurm--slurm_user_uid"></a>`slurm_user_uid`

Data type: `Optional[Integer]`



Default value: `undef`

##### <a name="-slurm--slurm_user_comment"></a>`slurm_user_comment`

Data type: `String[1]`



Default value: `'SLURM User'`

##### <a name="-slurm--slurm_user_home"></a>`slurm_user_home`

Data type: `Stdlib::Absolutepath`



Default value: `'/var/lib/slurm'`

##### <a name="-slurm--slurm_user_managehome"></a>`slurm_user_managehome`

Data type: `Boolean`



Default value: `true`

##### <a name="-slurm--slurm_user_shell"></a>`slurm_user_shell`

Data type: `Stdlib::Absolutepath`



Default value: `'/sbin/nologin'`

##### <a name="-slurm--slurmd_user"></a>`slurmd_user`

Data type: `String[1]`



Default value: `'root'`

##### <a name="-slurm--slurmd_user_group"></a>`slurmd_user_group`

Data type: `String[1]`



Default value: `'root'`

##### <a name="-slurm--manage_munge"></a>`manage_munge`

Data type: `Boolean`



Default value: `false`

##### <a name="-slurm--munge_key_source"></a>`munge_key_source`

Data type: `Optional[String]`



Default value: `undef`

##### <a name="-slurm--munge_key_content"></a>`munge_key_content`

Data type: `Optional[String]`



Default value: `undef`

##### <a name="-slurm--manage_slurm_conf"></a>`manage_slurm_conf`

Data type: `Boolean`



Default value: `true`

##### <a name="-slurm--manage_scripts"></a>`manage_scripts`

Data type: `Boolean`



Default value: `true`

##### <a name="-slurm--manage_firewall"></a>`manage_firewall`

Data type: `Boolean`



Default value: `true`

##### <a name="-slurm--use_syslog"></a>`use_syslog`

Data type: `Boolean`



Default value: `false`

##### <a name="-slurm--manage_logrotate"></a>`manage_logrotate`

Data type: `Boolean`



Default value: `true`

##### <a name="-slurm--logrotate_syslog_pid_path"></a>`logrotate_syslog_pid_path`

Data type: `Stdlib::Absolutepath`



Default value: `'/var/run/syslogd.pid'`

##### <a name="-slurm--manage_rsyslog"></a>`manage_rsyslog`

Data type: `Boolean`



Default value: `true`

##### <a name="-slurm--manage_database"></a>`manage_database`

Data type: `Boolean`



Default value: `true`

##### <a name="-slurm--export_database"></a>`export_database`

Data type: `Boolean`



Default value: `false`

##### <a name="-slurm--export_database_tag"></a>`export_database_tag`

Data type: `Optional[String[1]]`



Default value: `$facts['networking']['domain']`

##### <a name="-slurm--cli_filter_lua_source"></a>`cli_filter_lua_source`

Data type: `Optional[String[1]]`



Default value: `undef`

##### <a name="-slurm--cli_filter_lua_content"></a>`cli_filter_lua_content`

Data type: `Optional[String[1]]`



Default value: `undef`

##### <a name="-slurm--scrun_lua_source"></a>`scrun_lua_source`

Data type: `Optional[String[1]]`



Default value: `undef`

##### <a name="-slurm--scrun_lua_content"></a>`scrun_lua_content`

Data type: `Optional[String[1]]`



Default value: `undef`

##### <a name="-slurm--state_dir_nfs_device"></a>`state_dir_nfs_device`

Data type: `Optional[String[1]]`



Default value: `undef`

##### <a name="-slurm--state_dir_nfs_options"></a>`state_dir_nfs_options`

Data type: `String[1]`



Default value: `'rw,sync,noexec,nolock,auto'`

##### <a name="-slurm--job_submit_lua_source"></a>`job_submit_lua_source`

Data type: `Optional[String[1]]`



Default value: `undef`

##### <a name="-slurm--job_submit_lua_content"></a>`job_submit_lua_content`

Data type: `Optional[String[1]]`



Default value: `undef`

##### <a name="-slurm--cluster_name"></a>`cluster_name`

Data type: `String[1]`



Default value: `'linux'`

##### <a name="-slurm--slurmctld_host"></a>`slurmctld_host`

Data type: `Variant[Array, String]`



Default value: `'slurm'`

##### <a name="-slurm--slurmdbd_host"></a>`slurmdbd_host`

Data type: `Stdlib::Host`



Default value: `'slurmdbd'`

##### <a name="-slurm--conf_dir"></a>`conf_dir`

Data type: `Stdlib::Absolutepath`



Default value: `'/etc/slurm'`

##### <a name="-slurm--log_dir"></a>`log_dir`

Data type: `Stdlib::Absolutepath`



Default value: `'/var/log/slurm'`

##### <a name="-slurm--env_dir"></a>`env_dir`

Data type: `Stdlib::Absolutepath`



Default value: `'/etc/sysconfig'`

##### <a name="-slurm--spank_plugins"></a>`spank_plugins`

Data type: `Hash`



Default value: `{}`

##### <a name="-slurm--enable_configless"></a>`enable_configless`

Data type: `Boolean`



Default value: `false`

##### <a name="-slurm--configless"></a>`configless`

Data type: `Boolean`



Default value: `false`

##### <a name="-slurm--conf_server"></a>`conf_server`

Data type: `Optional[String]`



Default value: `undef`

##### <a name="-slurm--slurm_conf_override"></a>`slurm_conf_override`

Data type: `Hash`



Default value: `{}`

##### <a name="-slurm--slurm_conf_template"></a>`slurm_conf_template`

Data type: `String[1]`



Default value: `'slurm/slurm.conf/slurm.conf.erb'`

##### <a name="-slurm--slurm_conf_source"></a>`slurm_conf_source`

Data type: `Optional[String[1]]`



Default value: `undef`

##### <a name="-slurm--partition_template"></a>`partition_template`

Data type: `String[1]`



Default value: `'slurm/slurm.conf/conf_values.erb'`

##### <a name="-slurm--partition_source"></a>`partition_source`

Data type: `Optional[String[1]]`



Default value: `undef`

##### <a name="-slurm--node_template"></a>`node_template`

Data type: `String[1]`



Default value: `'slurm/slurm.conf/conf_values.erb'`

##### <a name="-slurm--node_source"></a>`node_source`

Data type: `Optional[String[1]]`



Default value: `undef`

##### <a name="-slurm--switch_template"></a>`switch_template`

Data type: `String[1]`



Default value: `'slurm/slurm.conf/conf_values.erb'`

##### <a name="-slurm--topology_source"></a>`topology_source`

Data type: `Optional[String[1]]`



Default value: `undef`

##### <a name="-slurm--gres_template"></a>`gres_template`

Data type: `String[1]`



Default value: `'slurm/slurm.conf/conf_values.erb'`

##### <a name="-slurm--gres_source"></a>`gres_source`

Data type: `Optional[String[1]]`



Default value: `undef`

##### <a name="-slurm--partitions"></a>`partitions`

Data type: `Hash`



Default value: `{}`

##### <a name="-slurm--nodes"></a>`nodes`

Data type: `Hash`



Default value: `{}`

##### <a name="-slurm--nodesets"></a>`nodesets`

Data type: `Hash`



Default value: `{}`

##### <a name="-slurm--switches"></a>`switches`

Data type: `Hash`



Default value: `{}`

##### <a name="-slurm--greses"></a>`greses`

Data type: `Hash`



Default value: `{}`

##### <a name="-slurm--job_containers"></a>`job_containers`

Data type: `Hash`



Default value: `{}`

##### <a name="-slurm--slurmd_log_file"></a>`slurmd_log_file`

Data type: `Optional[Stdlib::Absolutepath]`



Default value: `undef`

##### <a name="-slurm--slurmd_spool_dir"></a>`slurmd_spool_dir`

Data type: `Stdlib::Absolutepath`



Default value: `'/var/spool/slurmd'`

##### <a name="-slurm--slurmctld_log_file"></a>`slurmctld_log_file`

Data type: `Optional[Stdlib::Absolutepath]`



Default value: `undef`

##### <a name="-slurm--state_save_location"></a>`state_save_location`

Data type: `Stdlib::Absolutepath`



Default value: `'/var/spool/slurmctld.state'`

##### <a name="-slurm--slurmdbd_archive_dir"></a>`slurmdbd_archive_dir`

Data type: `Stdlib::Absolutepath`



Default value: `'/var/lib/slurmdbd.archive'`

##### <a name="-slurm--slurmdbd_log_file"></a>`slurmdbd_log_file`

Data type: `Optional[Stdlib::Absolutepath]`



Default value: `undef`

##### <a name="-slurm--slurmdbd_storage_host"></a>`slurmdbd_storage_host`

Data type: `Stdlib::Host`



Default value: `'localhost'`

##### <a name="-slurm--slurmdbd_storage_loc"></a>`slurmdbd_storage_loc`

Data type: `String[1]`



Default value: `'slurm_acct_db'`

##### <a name="-slurm--slurmdbd_storage_pass"></a>`slurmdbd_storage_pass`

Data type: `String[1]`



Default value: `'slurmdbd'`

##### <a name="-slurm--slurmdbd_storage_port"></a>`slurmdbd_storage_port`

Data type: `Variant[Stdlib::Port, String[0,0]]`



Default value: `3306`

##### <a name="-slurm--slurmdbd_storage_type"></a>`slurmdbd_storage_type`

Data type: `String[1]`



Default value: `'accounting_storage/mysql'`

##### <a name="-slurm--slurmdbd_storage_user"></a>`slurmdbd_storage_user`

Data type: `String[1]`



Default value: `'slurmdbd'`

##### <a name="-slurm--slurmdbd_db_charset"></a>`slurmdbd_db_charset`

Data type: `String[1]`



Default value: `'utf8'`

##### <a name="-slurm--slurmdbd_db_collate"></a>`slurmdbd_db_collate`

Data type: `String[1]`



Default value: `'utf8_general_ci'`

##### <a name="-slurm--slurmdbd_conf_override"></a>`slurmdbd_conf_override`

Data type: `Hash`



Default value: `{}`

##### <a name="-slurm--slurmdbd_archive_dir_nfs_device"></a>`slurmdbd_archive_dir_nfs_device`

Data type: `Optional[String[1]]`



Default value: `undef`

##### <a name="-slurm--slurmdbd_archive_dir_nfs_options"></a>`slurmdbd_archive_dir_nfs_options`

Data type: `String[1]`



Default value: `'rw,sync,noexec,nolock,auto'`

##### <a name="-slurm--use_nhc"></a>`use_nhc`

Data type: `Boolean`



Default value: `false`

##### <a name="-slurm--include_nhc"></a>`include_nhc`

Data type: `Boolean`



Default value: `false`

##### <a name="-slurm--health_check_program"></a>`health_check_program`

Data type: `Optional[Stdlib::Absolutepath]`



Default value: `undef`

##### <a name="-slurm--health_check_program_source"></a>`health_check_program_source`

Data type: `Optional[String[1]]`



Default value: `undef`

##### <a name="-slurm--manage_epilog"></a>`manage_epilog`

Data type: `Boolean`



Default value: `true`

##### <a name="-slurm--epilog"></a>`epilog`

Data type: `Optional[String[1]]`



Default value: `undef`

##### <a name="-slurm--epilog_source"></a>`epilog_source`

Data type: `Optional[Variant[String[1], Array[String[1]]]]`



Default value: `undef`

##### <a name="-slurm--epilog_sourceselect"></a>`epilog_sourceselect`

Data type: `Optional[String[1]]`



Default value: `undef`

##### <a name="-slurm--manage_prolog"></a>`manage_prolog`

Data type: `Boolean`



Default value: `true`

##### <a name="-slurm--prolog"></a>`prolog`

Data type: `Optional[String[1]]`



Default value: `undef`

##### <a name="-slurm--prolog_source"></a>`prolog_source`

Data type: `Optional[Variant[String[1], Array[String[1]]]]`



Default value: `undef`

##### <a name="-slurm--prolog_sourceselect"></a>`prolog_sourceselect`

Data type: `Optional[String[1]]`



Default value: `undef`

##### <a name="-slurm--manage_task_epilog"></a>`manage_task_epilog`

Data type: `Boolean`



Default value: `true`

##### <a name="-slurm--task_epilog"></a>`task_epilog`

Data type: `Optional[String[1]]`



Default value: `undef`

##### <a name="-slurm--task_epilog_source"></a>`task_epilog_source`

Data type: `Optional[Variant[String[1], Array[String[1]]]]`



Default value: `undef`

##### <a name="-slurm--manage_task_prolog"></a>`manage_task_prolog`

Data type: `Boolean`



Default value: `true`

##### <a name="-slurm--task_prolog"></a>`task_prolog`

Data type: `Optional[String[1]]`



Default value: `undef`

##### <a name="-slurm--task_prolog_source"></a>`task_prolog_source`

Data type: `Optional[Variant[String[1], Array[String[1]]]]`



Default value: `undef`

##### <a name="-slurm--auth_alt_types"></a>`auth_alt_types`

Data type: `Array`



Default value: `[]`

##### <a name="-slurm--jwt_key_content"></a>`jwt_key_content`

Data type: `Optional[String]`



Default value: `undef`

##### <a name="-slurm--jwt_key_source"></a>`jwt_key_source`

Data type: `Optional[String]`



Default value: `undef`

##### <a name="-slurm--slurmrestd_listen_address"></a>`slurmrestd_listen_address`

Data type: `String`



Default value: `$facts['networking']['ip']`

##### <a name="-slurm--slurmrestd_disable_token_creation"></a>`slurmrestd_disable_token_creation`

Data type: `Boolean`



Default value: `false`

##### <a name="-slurm--slurmrestd_user"></a>`slurmrestd_user`

Data type: `String`



Default value: `'daemon'`

##### <a name="-slurm--slurmrestd_user_group"></a>`slurmrestd_user_group`

Data type: `String`



Default value: `'daemon'`

##### <a name="-slurm--slurmrestd_service_ensure"></a>`slurmrestd_service_ensure`

Data type: `Enum['running','stopped']`



Default value: `'running'`

##### <a name="-slurm--slurmrestd_service_enable"></a>`slurmrestd_service_enable`

Data type: `Boolean`



Default value: `true`

##### <a name="-slurm--slurmrestd_service_limits"></a>`slurmrestd_service_limits`

Data type: `Hash`



Default value: `{}`

##### <a name="-slurm--slurmrestd_options"></a>`slurmrestd_options`

Data type: `Optional[String[1]]`



Default value: `undef`

##### <a name="-slurm--slurmrestd_restart_on_failure"></a>`slurmrestd_restart_on_failure`

Data type: `Boolean`



Default value: `true`

##### <a name="-slurm--cgroup_conf_template"></a>`cgroup_conf_template`

Data type: `String`



Default value: `'slurm/cgroup/cgroup.conf.erb'`

##### <a name="-slurm--cgroup_conf_source"></a>`cgroup_conf_source`

Data type: `Optional[String]`



Default value: `undef`

##### <a name="-slurm--cgroup_mountpoint"></a>`cgroup_mountpoint`

Data type: `Stdlib::Absolutepath`



Default value: `'/sys/fs/cgroup'`

##### <a name="-slurm--cgroup_plugin"></a>`cgroup_plugin`

Data type: `String`



Default value: `'autodetect'`

##### <a name="-slurm--cgroup_allowed_ram_space"></a>`cgroup_allowed_ram_space`

Data type: `Integer`



Default value: `100`

##### <a name="-slurm--cgroup_allowed_swap_space"></a>`cgroup_allowed_swap_space`

Data type: `Integer`



Default value: `0`

##### <a name="-slurm--cgroup_constrain_cores"></a>`cgroup_constrain_cores`

Data type: `Boolean`



Default value: `false`

##### <a name="-slurm--cgroup_constrain_devices"></a>`cgroup_constrain_devices`

Data type: `Boolean`



Default value: `false`

##### <a name="-slurm--cgroup_constrain_ram_space"></a>`cgroup_constrain_ram_space`

Data type: `Boolean`



Default value: `false`

##### <a name="-slurm--cgroup_constrain_swap_space"></a>`cgroup_constrain_swap_space`

Data type: `Boolean`



Default value: `false`

##### <a name="-slurm--cgroup_max_ram_percent"></a>`cgroup_max_ram_percent`

Data type: `Integer`



Default value: `100`

##### <a name="-slurm--cgroup_max_swap_percent"></a>`cgroup_max_swap_percent`

Data type: `Integer`



Default value: `100`

##### <a name="-slurm--cgroup_memory_swappiness"></a>`cgroup_memory_swappiness`

Data type: `Optional[Integer[0,100]]`



Default value: `undef`

##### <a name="-slurm--cgroup_min_ram_space"></a>`cgroup_min_ram_space`

Data type: `Integer`



Default value: `30`

##### <a name="-slurm--cgroup_signal_child_processes"></a>`cgroup_signal_child_processes`

Data type: `Optional[Boolean]`



Default value: `undef`

##### <a name="-slurm--oci_conf_template"></a>`oci_conf_template`

Data type: `String`



Default value: `'slurm/oci.conf.erb'`

##### <a name="-slurm--oci_conf_source"></a>`oci_conf_source`

Data type: `Optional[String]`



Default value: `undef`

##### <a name="-slurm--oci_container_path"></a>`oci_container_path`

Data type: `Optional[String[1]]`



Default value: `undef`

##### <a name="-slurm--oci_create_env_file"></a>`oci_create_env_file`

Data type: `String[1]`



Default value: `'disabled'`

##### <a name="-slurm--oci_debug_flags"></a>`oci_debug_flags`

Data type: `Optional[String[1]]`



Default value: `undef`

##### <a name="-slurm--oci_disable_cleanup"></a>`oci_disable_cleanup`

Data type: `Boolean`



Default value: `false`

##### <a name="-slurm--oci_disable_hooks"></a>`oci_disable_hooks`

Data type: `Optional[String[1]]`



Default value: `undef`

##### <a name="-slurm--oci_env_exclude"></a>`oci_env_exclude`

Data type: `Optional[String[1]]`



Default value: `undef`

##### <a name="-slurm--oci_mount_spool_dir"></a>`oci_mount_spool_dir`

Data type: `Stdlib::Absolutepath`



Default value: `'/var/run/slurm/'`

##### <a name="-slurm--oci_run_time_env_exclude"></a>`oci_run_time_env_exclude`

Data type: `Optional[String[1]]`



Default value: `undef`

##### <a name="-slurm--oci_file_debug"></a>`oci_file_debug`

Data type: `Optional[String[1]]`



Default value: `undef`

##### <a name="-slurm--oci_ignore_file_config_json"></a>`oci_ignore_file_config_json`

Data type: `Boolean`



Default value: `false`

##### <a name="-slurm--oci_run_time_create"></a>`oci_run_time_create`

Data type: `Optional[String[1]]`



Default value: `undef`

##### <a name="-slurm--oci_run_time_delete"></a>`oci_run_time_delete`

Data type: `Optional[String[1]]`



Default value: `undef`

##### <a name="-slurm--oci_run_time_kill"></a>`oci_run_time_kill`

Data type: `Optional[String[1]]`



Default value: `undef`

##### <a name="-slurm--oci_run_time_query"></a>`oci_run_time_query`

Data type: `Optional[String[1]]`



Default value: `undef`

##### <a name="-slurm--oci_run_time_run"></a>`oci_run_time_run`

Data type: `Optional[String[1]]`



Default value: `undef`

##### <a name="-slurm--oci_run_time_start"></a>`oci_run_time_start`

Data type: `Optional[String[1]]`



Default value: `undef`

##### <a name="-slurm--oci_srun_path"></a>`oci_srun_path`

Data type: `Optional[Stdlib::Absolutepath]`



Default value: `undef`

##### <a name="-slurm--oci_srun_args"></a>`oci_srun_args`

Data type: `Optional[String[1]]`



Default value: `undef`

##### <a name="-slurm--oci_std_io_debug"></a>`oci_std_io_debug`

Data type: `Optional[String[1]]`



Default value: `undef`

##### <a name="-slurm--oci_syslog_debug"></a>`oci_syslog_debug`

Data type: `Optional[String[1]]`



Default value: `undef`

##### <a name="-slurm--slurm_sh_template"></a>`slurm_sh_template`

Data type: `String[1]`



Default value: `'slurm/profile.d/slurm.sh.erb'`

##### <a name="-slurm--slurm_csh_template"></a>`slurm_csh_template`

Data type: `String[1]`



Default value: `'slurm/profile.d/slurm.csh.erb'`

##### <a name="-slurm--profile_d_env_vars"></a>`profile_d_env_vars`

Data type: `Hash`



Default value: `{}`

##### <a name="-slurm--slurmd_port"></a>`slurmd_port`

Data type: `Stdlib::Port`



Default value: `6818`

##### <a name="-slurm--slurmctld_port"></a>`slurmctld_port`

Data type: `Stdlib::Port`



Default value: `6817`

##### <a name="-slurm--slurmdbd_port"></a>`slurmdbd_port`

Data type: `Stdlib::Port`



Default value: `6819`

##### <a name="-slurm--slurmrestd_port"></a>`slurmrestd_port`

Data type: `Stdlib::Port`



Default value: `6820`

##### <a name="-slurm--tuning_net_core_somaxconn"></a>`tuning_net_core_somaxconn`

Data type: `Variant[Boolean, Integer]`



Default value: `1024`

##### <a name="-slurm--include_resources"></a>`include_resources`

Data type: `Boolean`



Default value: `false`

##### <a name="-slurm--clusters"></a>`clusters`

Data type: `Hash`



Default value: `{}`

##### <a name="-slurm--qoses"></a>`qoses`

Data type: `Hash`



Default value: `{}`

##### <a name="-slurm--reservations"></a>`reservations`

Data type: `Hash`



Default value: `{}`

##### <a name="-slurm--accounts"></a>`accounts`

Data type: `Hash`



Default value: `{}`

##### <a name="-slurm--users"></a>`users`

Data type: `Hash`



Default value: `{}`

##### <a name="-slurm--licenses"></a>`licenses`

Data type: `Hash`



Default value: `{}`

##### <a name="-slurm--purge_qos"></a>`purge_qos`

Data type: `Boolean`



Default value: `false`

##### <a name="-slurm--slurmdbd_conn_validator_timeout"></a>`slurmdbd_conn_validator_timeout`

Data type: `Integer`



Default value: `30`

## Defined types

### <a name="slurm--conf"></a>`slurm::conf`

Manage Slurm main configuration

#### Examples

##### Create /etc/slurm/slurm-ascend.conf

```puppet

include slurm
$cluster_conf = {
  'ClusterName'   => 'ascend',
  'SlurmctldHost' => 'ascend-slurm01.example.com',
}
slurm::conf { 'ascend':
  configs => $slurm::slurm_conf + $cluster_conf,
}
```

#### Parameters

The following parameters are available in the `slurm::conf` defined type:

* [`configs`](#-slurm--conf--configs)
* [`template`](#-slurm--conf--template)
* [`source`](#-slurm--conf--source)
* [`config_name`](#-slurm--conf--config_name)

##### <a name="-slurm--conf--configs"></a>`configs`

Data type: `Hash`

Hash of Slurm configs

Default value: `{}`

##### <a name="-slurm--conf--template"></a>`template`

Data type: `Optional[String]`

Template to use to generate slurm.conf contents

Default value: `undef`

##### <a name="-slurm--conf--source"></a>`source`

Data type: `Optional[String]`

Source of configuration instead of templated configs

Default value: `undef`

##### <a name="-slurm--conf--config_name"></a>`config_name`

Data type: `String`

Name of configuration file

Default value: `"slurm-${name}.conf"`

### <a name="slurm--down_node"></a>`slurm::down_node`

Manage SLURM down node configuration

#### Parameters

The following parameters are available in the `slurm::down_node` defined type:

* [`down_nodes`](#-slurm--down_node--down_nodes)
* [`reason`](#-slurm--down_node--reason)
* [`state`](#-slurm--down_node--state)
* [`target`](#-slurm--down_node--target)
* [`order`](#-slurm--down_node--order)

##### <a name="-slurm--down_node--down_nodes"></a>`down_nodes`

Data type: `String`



Default value: `$name`

##### <a name="-slurm--down_node--reason"></a>`reason`

Data type: `Optional[String]`



Default value: `undef`

##### <a name="-slurm--down_node--state"></a>`state`

Data type: `Slurm::DownNodeState`



Default value: `'UNKNOWN'`

##### <a name="-slurm--down_node--target"></a>`target`

Data type: `String`



Default value: `'slurm.conf'`

##### <a name="-slurm--down_node--order"></a>`order`

Data type: `Variant[String[1], Integer]`



Default value: `'75'`

### <a name="slurm--gres"></a>`slurm::gres`

Manage SLURM GRES configuration

#### Examples

##### Add static GPU GRES

```puppet
slurm::gres { 'gpu':
  type  => 'v100',
  file  => '/dev/nvidia0',
  cores => '0,1',
}
```

##### Add nvml AutoDetect gres

```puppet
slurm::gres { 'nvml':
  auto_detect => 'nvml',
}
```

#### Parameters

The following parameters are available in the `slurm::gres` defined type:

* [`gres_name`](#-slurm--gres--gres_name)
* [`type`](#-slurm--gres--type)
* [`node_name`](#-slurm--gres--node_name)
* [`auto_detect`](#-slurm--gres--auto_detect)
* [`count`](#-slurm--gres--count)
* [`cores`](#-slurm--gres--cores)
* [`file`](#-slurm--gres--file)
* [`flags`](#-slurm--gres--flags)
* [`links`](#-slurm--gres--links)
* [`order`](#-slurm--gres--order)

##### <a name="-slurm--gres--gres_name"></a>`gres_name`

Data type: `String[1]`



Default value: `$name`

##### <a name="-slurm--gres--type"></a>`type`

Data type: `Optional[String[1]]`



Default value: `undef`

##### <a name="-slurm--gres--node_name"></a>`node_name`

Data type: `Optional[Variant[String[1], Array[String[1]]]]`



Default value: `undef`

##### <a name="-slurm--gres--auto_detect"></a>`auto_detect`

Data type: `Optional[Enum['nvml','rsmi','oneapi','off']]`



Default value: `undef`

##### <a name="-slurm--gres--count"></a>`count`

Data type: `Optional[Variant[String[1], Integer]]`



Default value: `undef`

##### <a name="-slurm--gres--cores"></a>`cores`

Data type: `Optional[Variant[String[1], Integer, Array[Variant[String[1],Integer]]]]`



Default value: `undef`

##### <a name="-slurm--gres--file"></a>`file`

Data type: `Optional[Stdlib::Absolutepath]`



Default value: `undef`

##### <a name="-slurm--gres--flags"></a>`flags`

Data type: `Optional[Enum['CountOnly']]`



Default value: `undef`

##### <a name="-slurm--gres--links"></a>`links`

Data type: `Optional[Variant[Integer, Array[Integer]]]`



Default value: `undef`

##### <a name="-slurm--gres--order"></a>`order`

Data type: `Variant[String[1], Integer]`



Default value: `'50'`

### <a name="slurm--job_container"></a>`slurm::job_container`

Manage SLURM job_container.conf entry

#### Parameters

The following parameters are available in the `slurm::job_container` defined type:

* [`base_path`](#-slurm--job_container--base_path)
* [`auto_base_path`](#-slurm--job_container--auto_base_path)
* [`dirs`](#-slurm--job_container--dirs)
* [`init_script`](#-slurm--job_container--init_script)
* [`node_name`](#-slurm--job_container--node_name)
* [`shared`](#-slurm--job_container--shared)
* [`order`](#-slurm--job_container--order)

##### <a name="-slurm--job_container--base_path"></a>`base_path`

Data type: `Stdlib::Absolutepath`

job_container.conf BasePath

##### <a name="-slurm--job_container--auto_base_path"></a>`auto_base_path`

Data type: `Boolean`

job_container.conf AutoBasePath

Default value: `false`

##### <a name="-slurm--job_container--dirs"></a>`dirs`

Data type: `Optional[Array[Stdlib::Absolutepath]]`

job_container.conf Dirs

Default value: `undef`

##### <a name="-slurm--job_container--init_script"></a>`init_script`

Data type: `Optional[Stdlib::Absolutepath]`

job_container.conf InitScript

Default value: `undef`

##### <a name="-slurm--job_container--node_name"></a>`node_name`

Data type: `Optional[String]`

job_container.conf NodeName

Default value: `undef`

##### <a name="-slurm--job_container--shared"></a>`shared`

Data type: `Optional[Boolean]`

job_container.conf Shared

Default value: `undef`

##### <a name="-slurm--job_container--order"></a>`order`

Data type: `Variant[String[1], Integer]`

Order in job_container.conf

Default value: `'50'`

### <a name="slurm--node"></a>`slurm::node`

Manage SLURM node configuration

#### Parameters

The following parameters are available in the `slurm::node` defined type:

* [`node_name`](#-slurm--node--node_name)
* [`node_hostname`](#-slurm--node--node_hostname)
* [`node_addr`](#-slurm--node--node_addr)
* [`bcast_addr`](#-slurm--node--bcast_addr)
* [`boards`](#-slurm--node--boards)
* [`core_spec_count`](#-slurm--node--core_spec_count)
* [`cores_per_socket`](#-slurm--node--cores_per_socket)
* [`cpu_bind`](#-slurm--node--cpu_bind)
* [`cpus`](#-slurm--node--cpus)
* [`cpu_spec_list`](#-slurm--node--cpu_spec_list)
* [`features`](#-slurm--node--features)
* [`gres`](#-slurm--node--gres)
* [`mem_spec_limit`](#-slurm--node--mem_spec_limit)
* [`port`](#-slurm--node--port)
* [`real_memory`](#-slurm--node--real_memory)
* [`reason`](#-slurm--node--reason)
* [`sockets`](#-slurm--node--sockets)
* [`sockets_per_board`](#-slurm--node--sockets_per_board)
* [`state`](#-slurm--node--state)
* [`threads_per_core`](#-slurm--node--threads_per_core)
* [`tmp_disk`](#-slurm--node--tmp_disk)
* [`weight`](#-slurm--node--weight)
* [`target`](#-slurm--node--target)
* [`order`](#-slurm--node--order)

##### <a name="-slurm--node--node_name"></a>`node_name`

Data type: `String[1]`



Default value: `$name`

##### <a name="-slurm--node--node_hostname"></a>`node_hostname`

Data type: `Optional[Stdlib::Host]`



Default value: `undef`

##### <a name="-slurm--node--node_addr"></a>`node_addr`

Data type: `Optional[Stdlib::IP::Address]`



Default value: `undef`

##### <a name="-slurm--node--bcast_addr"></a>`bcast_addr`

Data type: `Optional[Stdlib::IP::Address]`



Default value: `undef`

##### <a name="-slurm--node--boards"></a>`boards`

Data type: `Optional[Variant[String[1], Integer]]`



Default value: `undef`

##### <a name="-slurm--node--core_spec_count"></a>`core_spec_count`

Data type: `Optional[Variant[String[1], Integer]]`



Default value: `undef`

##### <a name="-slurm--node--cores_per_socket"></a>`cores_per_socket`

Data type: `Optional[Variant[String[1], Integer]]`



Default value: `undef`

##### <a name="-slurm--node--cpu_bind"></a>`cpu_bind`

Data type: `Optional[Slurm::CPUBind]`



Default value: `undef`

##### <a name="-slurm--node--cpus"></a>`cpus`

Data type: `Optional[Variant[String[1], Integer]]`



Default value: `undef`

##### <a name="-slurm--node--cpu_spec_list"></a>`cpu_spec_list`

Data type: `Optional[Variant[String[1], Array[String[1]]]]`



Default value: `undef`

##### <a name="-slurm--node--features"></a>`features`

Data type: `Optional[Variant[String[1], Array[String[1]]]]`



Default value: `undef`

##### <a name="-slurm--node--gres"></a>`gres`

Data type: `Optional[Variant[String[1], Array[String[1]]]]`



Default value: `undef`

##### <a name="-slurm--node--mem_spec_limit"></a>`mem_spec_limit`

Data type: `Optional[Variant[String[1], Integer]]`



Default value: `undef`

##### <a name="-slurm--node--port"></a>`port`

Data type: `Optional[Stdlib::Port]`



Default value: `undef`

##### <a name="-slurm--node--real_memory"></a>`real_memory`

Data type: `Optional[Variant[String[1], Integer]]`



Default value: `undef`

##### <a name="-slurm--node--reason"></a>`reason`

Data type: `Optional[String[1]]`



Default value: `undef`

##### <a name="-slurm--node--sockets"></a>`sockets`

Data type: `Optional[Variant[String[1], Integer]]`



Default value: `undef`

##### <a name="-slurm--node--sockets_per_board"></a>`sockets_per_board`

Data type: `Optional[Variant[String[1], Integer]]`



Default value: `undef`

##### <a name="-slurm--node--state"></a>`state`

Data type: `Slurm::NodeState`



Default value: `'UNKNOWN'`

##### <a name="-slurm--node--threads_per_core"></a>`threads_per_core`

Data type: `Optional[Variant[String[1], Integer]]`



Default value: `undef`

##### <a name="-slurm--node--tmp_disk"></a>`tmp_disk`

Data type: `Optional[Integer]`



Default value: `undef`

##### <a name="-slurm--node--weight"></a>`weight`

Data type: `Optional[Integer]`



Default value: `undef`

##### <a name="-slurm--node--target"></a>`target`

Data type: `String[1]`



Default value: `'slurm.conf'`

##### <a name="-slurm--node--order"></a>`order`

Data type: `Variant[String[1], Integer]`



Default value: `'90'`

### <a name="slurm--nodeset"></a>`slurm::nodeset`

Manage SLURM nodeset configuration

#### Parameters

The following parameters are available in the `slurm::nodeset` defined type:

* [`feature`](#-slurm--nodeset--feature)
* [`nodes`](#-slurm--nodeset--nodes)
* [`node_set`](#-slurm--nodeset--node_set)
* [`target`](#-slurm--nodeset--target)
* [`order`](#-slurm--nodeset--order)

##### <a name="-slurm--nodeset--feature"></a>`feature`

Data type: `Optional[String]`



Default value: `undef`

##### <a name="-slurm--nodeset--nodes"></a>`nodes`

Data type: `Optional[String]`



Default value: `undef`

##### <a name="-slurm--nodeset--node_set"></a>`node_set`

Data type: `String`



Default value: `$name`

##### <a name="-slurm--nodeset--target"></a>`target`

Data type: `String[1]`



Default value: `'slurm.conf'`

##### <a name="-slurm--nodeset--order"></a>`order`

Data type: `Variant[String[1], Integer]`



Default value: `'40'`

### <a name="slurm--partition"></a>`slurm::partition`

Manage a SLURM partition configuration

#### Parameters

The following parameters are available in the `slurm::partition` defined type:

* [`partition_name`](#-slurm--partition--partition_name)
* [`alloc_nodes`](#-slurm--partition--alloc_nodes)
* [`allow_accounts`](#-slurm--partition--allow_accounts)
* [`allow_groups`](#-slurm--partition--allow_groups)
* [`allow_qos`](#-slurm--partition--allow_qos)
* [`alternate`](#-slurm--partition--alternate)
* [`cpu_bind`](#-slurm--partition--cpu_bind)
* [`default`](#-slurm--partition--default)
* [`def_cpu_per_gpu`](#-slurm--partition--def_cpu_per_gpu)
* [`def_mem_per_cpu`](#-slurm--partition--def_mem_per_cpu)
* [`def_mem_per_gpu`](#-slurm--partition--def_mem_per_gpu)
* [`def_mem_per_node`](#-slurm--partition--def_mem_per_node)
* [`deny_accounts`](#-slurm--partition--deny_accounts)
* [`deny_qos`](#-slurm--partition--deny_qos)
* [`default_time`](#-slurm--partition--default_time)
* [`disable_root_jobs`](#-slurm--partition--disable_root_jobs)
* [`exclusive_user`](#-slurm--partition--exclusive_user)
* [`grace_time`](#-slurm--partition--grace_time)
* [`hidden`](#-slurm--partition--hidden)
* [`lln`](#-slurm--partition--lln)
* [`max_cpus_per_node`](#-slurm--partition--max_cpus_per_node)
* [`max_mem_per_cpu`](#-slurm--partition--max_mem_per_cpu)
* [`max_mem_per_node`](#-slurm--partition--max_mem_per_node)
* [`max_nodes`](#-slurm--partition--max_nodes)
* [`max_time`](#-slurm--partition--max_time)
* [`min_nodes`](#-slurm--partition--min_nodes)
* [`nodes`](#-slurm--partition--nodes)
* [`over_subscribe`](#-slurm--partition--over_subscribe)
* [`over_time_limit`](#-slurm--partition--over_time_limit)
* [`preempt_mode`](#-slurm--partition--preempt_mode)
* [`priority_job_factor`](#-slurm--partition--priority_job_factor)
* [`priority_tier`](#-slurm--partition--priority_tier)
* [`qos`](#-slurm--partition--qos)
* [`req_resv`](#-slurm--partition--req_resv)
* [`resume_timeout`](#-slurm--partition--resume_timeout)
* [`root_only`](#-slurm--partition--root_only)
* [`select_type_parameters`](#-slurm--partition--select_type_parameters)
* [`shared`](#-slurm--partition--shared)
* [`state`](#-slurm--partition--state)
* [`suspend_time`](#-slurm--partition--suspend_time)
* [`suspend_timeout`](#-slurm--partition--suspend_timeout)
* [`tres_billing_weights`](#-slurm--partition--tres_billing_weights)
* [`target`](#-slurm--partition--target)
* [`order`](#-slurm--partition--order)

##### <a name="-slurm--partition--partition_name"></a>`partition_name`

Data type: `String[1]`



Default value: `$name`

##### <a name="-slurm--partition--alloc_nodes"></a>`alloc_nodes`

Data type: `Optional[Variant[String[1], Array[String[1]]]]`



Default value: `undef`

##### <a name="-slurm--partition--allow_accounts"></a>`allow_accounts`

Data type: `Optional[Variant[String[1], Array[String[1]]]]`



Default value: `undef`

##### <a name="-slurm--partition--allow_groups"></a>`allow_groups`

Data type: `Optional[Variant[String[1], Array[String[1]]]]`



Default value: `undef`

##### <a name="-slurm--partition--allow_qos"></a>`allow_qos`

Data type: `Optional[Variant[String[1], Array[String[1]]]]`



Default value: `undef`

##### <a name="-slurm--partition--alternate"></a>`alternate`

Data type: `Optional[String[1]]`



Default value: `undef`

##### <a name="-slurm--partition--cpu_bind"></a>`cpu_bind`

Data type: `Optional[Slurm::CPUBind]`



Default value: `undef`

##### <a name="-slurm--partition--default"></a>`default`

Data type: `Optional[Slurm::YesNo]`



Default value: `undef`

##### <a name="-slurm--partition--def_cpu_per_gpu"></a>`def_cpu_per_gpu`

Data type: `Optional[Variant[String[1], Integer]]`



Default value: `undef`

##### <a name="-slurm--partition--def_mem_per_cpu"></a>`def_mem_per_cpu`

Data type: `Optional[Variant[String[1], Integer]]`



Default value: `undef`

##### <a name="-slurm--partition--def_mem_per_gpu"></a>`def_mem_per_gpu`

Data type: `Optional[Variant[String[1], Integer]]`



Default value: `undef`

##### <a name="-slurm--partition--def_mem_per_node"></a>`def_mem_per_node`

Data type: `Optional[Variant[String[1], Integer]]`



Default value: `undef`

##### <a name="-slurm--partition--deny_accounts"></a>`deny_accounts`

Data type: `Optional[Variant[String[1], Array[String[1]]]]`



Default value: `undef`

##### <a name="-slurm--partition--deny_qos"></a>`deny_qos`

Data type: `Optional[Variant[String[1], Array[String[1]]]]`



Default value: `undef`

##### <a name="-slurm--partition--default_time"></a>`default_time`

Data type: `Optional[String[1]]`



Default value: `undef`

##### <a name="-slurm--partition--disable_root_jobs"></a>`disable_root_jobs`

Data type: `Optional[Slurm::YesNo]`



Default value: `undef`

##### <a name="-slurm--partition--exclusive_user"></a>`exclusive_user`

Data type: `Optional[Slurm::YesNo]`



Default value: `undef`

##### <a name="-slurm--partition--grace_time"></a>`grace_time`

Data type: `Optional[Variant[String[1], Integer]]`



Default value: `undef`

##### <a name="-slurm--partition--hidden"></a>`hidden`

Data type: `Optional[Slurm::YesNo]`



Default value: `undef`

##### <a name="-slurm--partition--lln"></a>`lln`

Data type: `Optional[Slurm::YesNo]`



Default value: `undef`

##### <a name="-slurm--partition--max_cpus_per_node"></a>`max_cpus_per_node`

Data type: `Optional[Variant[String[1], Integer]]`



Default value: `undef`

##### <a name="-slurm--partition--max_mem_per_cpu"></a>`max_mem_per_cpu`

Data type: `Optional[Variant[String[1], Integer]]`



Default value: `undef`

##### <a name="-slurm--partition--max_mem_per_node"></a>`max_mem_per_node`

Data type: `Optional[Variant[String[1], Integer]]`



Default value: `undef`

##### <a name="-slurm--partition--max_nodes"></a>`max_nodes`

Data type: `Optional[Variant[String[1], Integer]]`



Default value: `undef`

##### <a name="-slurm--partition--max_time"></a>`max_time`

Data type: `Optional[String[1]]`



Default value: `undef`

##### <a name="-slurm--partition--min_nodes"></a>`min_nodes`

Data type: `Optional[Variant[String[1], Integer]]`



Default value: `undef`

##### <a name="-slurm--partition--nodes"></a>`nodes`

Data type: `Optional[Variant[String[1], Array[String[1]]]]`



Default value: `undef`

##### <a name="-slurm--partition--over_subscribe"></a>`over_subscribe`

Data type: `Optional[Enum['EXCLUSIVE','FORCE','YES','NO']]`



Default value: `undef`

##### <a name="-slurm--partition--over_time_limit"></a>`over_time_limit`

Data type: `Optional[Variant[String[1], Integer]]`



Default value: `undef`

##### <a name="-slurm--partition--preempt_mode"></a>`preempt_mode`

Data type: `Optional[Slurm::PreemptMode]`



Default value: `undef`

##### <a name="-slurm--partition--priority_job_factor"></a>`priority_job_factor`

Data type: `Optional[Variant[String[1], Integer]]`



Default value: `undef`

##### <a name="-slurm--partition--priority_tier"></a>`priority_tier`

Data type: `Optional[Variant[String[1], Integer]]`



Default value: `undef`

##### <a name="-slurm--partition--qos"></a>`qos`

Data type: `Optional[String[1]]`



Default value: `undef`

##### <a name="-slurm--partition--req_resv"></a>`req_resv`

Data type: `Optional[Slurm::YesNo]`



Default value: `undef`

##### <a name="-slurm--partition--resume_timeout"></a>`resume_timeout`

Data type: `Optional[Variant[String[1], Integer]]`



Default value: `undef`

##### <a name="-slurm--partition--root_only"></a>`root_only`

Data type: `Optional[Slurm::YesNo]`



Default value: `undef`

##### <a name="-slurm--partition--select_type_parameters"></a>`select_type_parameters`

Data type: `Optional[Slurm::SelectTypeParameters]`



Default value: `undef`

##### <a name="-slurm--partition--shared"></a>`shared`

Data type: `Optional[Enum['EXCLUSIVE','FORCE','YES','NO']]`



Default value: `undef`

##### <a name="-slurm--partition--state"></a>`state`

Data type: `Slurm::PartitionState`



Default value: `'UP'`

##### <a name="-slurm--partition--suspend_time"></a>`suspend_time`

Data type: `Optional[Variant[String[1], Integer]]`



Default value: `undef`

##### <a name="-slurm--partition--suspend_timeout"></a>`suspend_timeout`

Data type: `Optional[Variant[String[1], Integer]]`



Default value: `undef`

##### <a name="-slurm--partition--tres_billing_weights"></a>`tres_billing_weights`

Data type: `Optional[Variant[String[1], Array[String[1]]]]`



Default value: `undef`

##### <a name="-slurm--partition--target"></a>`target`

Data type: `String[1]`



Default value: `'slurm.conf'`

##### <a name="-slurm--partition--order"></a>`order`

Data type: `Variant[String[1], Integer]`



Default value: `'50'`

### <a name="slurm--spank"></a>`slurm::spank`

Manage SLURM SPANK plugin

#### Parameters

The following parameters are available in the `slurm::spank` defined type:

* [`ensure`](#-slurm--spank--ensure)
* [`plugin`](#-slurm--spank--plugin)
* [`arguments`](#-slurm--spank--arguments)
* [`required`](#-slurm--spank--required)
* [`manage_package`](#-slurm--spank--manage_package)
* [`package_name`](#-slurm--spank--package_name)
* [`package_ensure`](#-slurm--spank--package_ensure)
* [`order`](#-slurm--spank--order)

##### <a name="-slurm--spank--ensure"></a>`ensure`

Data type: `Enum['present','absent']`

Ensure state of SPANK plugin

Default value: `'present'`

##### <a name="-slurm--spank--plugin"></a>`plugin`

Data type: `String`

The shared library

Default value: `"${name}.so"`

##### <a name="-slurm--spank--arguments"></a>`arguments`

Data type: `Optional[Variant[Hash, Array, String]]`

Arguments for the plugin

Default value: `undef`

##### <a name="-slurm--spank--required"></a>`required`

Data type: `Boolean`

Is this plugin required?

Default value: `false`

##### <a name="-slurm--spank--manage_package"></a>`manage_package`

Data type: `Boolean`

Manage plugin package?

Default value: `true`

##### <a name="-slurm--spank--package_name"></a>`package_name`

Data type: `String`

Plugin package name

Default value: `"slurm-spank-${name}"`

##### <a name="-slurm--spank--package_ensure"></a>`package_ensure`

Data type: `String`

Plugin package ensure value

Default value: `'installed'`

##### <a name="-slurm--spank--order"></a>`order`

Data type: `Variant[String[1], Integer]`

Order in plugstack.conf

Default value: `'50'`

### <a name="slurm--switch"></a>`slurm::switch`

Add switch to topology.conf

#### Examples

##### 

```puppet
slurm::switch { 'switch1':
  switches => 'switch[2-3],
}
slurm::switch { 'switch2':
  nodes => 'c0[1-2]',
}
```

#### Parameters

The following parameters are available in the `slurm::switch` defined type:

* [`switch_name`](#-slurm--switch--switch_name)
* [`switches`](#-slurm--switch--switches)
* [`nodes`](#-slurm--switch--nodes)
* [`link_speed`](#-slurm--switch--link_speed)
* [`order`](#-slurm--switch--order)

##### <a name="-slurm--switch--switch_name"></a>`switch_name`

Data type: `String[1]`

= $name,
SwitchName value, see man page for topology.conf

Default value: `$name`

##### <a name="-slurm--switch--switches"></a>`switches`

Data type: `Optional[String[1]]`

= undef,
Switches value, see man page for topology.conf

Default value: `undef`

##### <a name="-slurm--switch--nodes"></a>`nodes`

Data type: `Optional[String[1]]`

= undef,
Nodes value, see man page for topology.conf

Default value: `undef`

##### <a name="-slurm--switch--link_speed"></a>`link_speed`

Data type: `Optional[String[1]]`

= undef,
LinkSpeed value, see man page for topology.conf

Default value: `undef`

##### <a name="-slurm--switch--order"></a>`order`

Data type: `Variant[String[1], Integer]`

= '50',
Order inside topology.conf

Default value: `'50'`

## Data types

### <a name="Slurm--CPUBind"></a>`Slurm::CPUBind`

Type for CPU bind settings

Alias of `Enum['none', 'socket', 'ldom', 'core', 'thread', 'UNSET']`

### <a name="Slurm--DownNodeState"></a>`Slurm::DownNodeState`

The Slurm::DownNodeState data type.

Alias of `Enum['DOWN', 'DRAIN', 'FAIL', 'FAILING', 'UNKNOWN']`

### <a name="Slurm--NodeState"></a>`Slurm::NodeState`

The Slurm::NodeState data type.

Alias of `Variant[Enum['CLOUD','FUTURE'], Slurm::DownNodeState]`

### <a name="Slurm--PartitionState"></a>`Slurm::PartitionState`

The Slurm::PartitionState data type.

Alias of `Enum['UP', 'DOWN', 'DRAIN', 'INACTIVE']`

### <a name="Slurm--PreemptMode"></a>`Slurm::PreemptMode`

The Slurm::PreemptMode data type.

Alias of `Enum['OFF', 'CANCEL', 'CHECKPOINT', 'GANG', 'REQUEUE', 'SUSPEND']`

### <a name="Slurm--SelectTypeParameters"></a>`Slurm::SelectTypeParameters`

The Slurm::SelectTypeParameters data type.

Alias of `Enum['CR_Core', 'CR_Core_Memory', 'CR_Socket', 'CR_Socket_Memory']`

### <a name="Slurm--YesNo"></a>`Slurm::YesNo`

The Slurm::YesNo data type.

Alias of `Enum['YES', 'NO', 'UNSET']`

## Tasks

### <a name="reconfig"></a>`reconfig`

Execute 'scontrol reconfig'

**Supports noop?** false

#### Parameters

##### `scontrol`

Data type: `String[1]`

Path to scontrol (default: 'scontrol', searches $PATH)

