# @api private
class slurm::params {
  $slurm_conf_multiple = [
    'SlurmctldHost',
  ]

  $slurm_conf_defaults = {
    'AccountingStorageBackupHost' => undef,
    'AccountingStorageEnforce' => undef,
    'AccountingStorageExternalHost' => undef,
    'AccountingStorageParameters' => undef,
    'AccountingStoragePass' => undef,
    'AccountingStoragePort' => undef,
    'AccountingStorageTRES' => undef,
    'AccountingStorageType' => 'accounting_storage/slurmdbd',
    'AccountingStorageUser' => undef,
    'AccountingStoreFlags' => undef,
    'AcctGatherNodeFreq' => '0',
    'AcctGatherEnergyType' => undef,
    'AcctGatherInterconnectType' => undef,
    'AcctGatherFilesystemType' => undef,
    'AcctGatherProfileType' => undef,
    'AllowSpecResourcesUsage' => 'NO',
    'AuthAltTypes' => undef,
    'AuthAltParameters' => undef,
    'AuthInfo' => undef,
    'AuthType' => 'auth/munge',
    'BatchStartTimeout' => '10',
    'BcastExclude' => undef,
    'BcastParameters' => undef,
    'BurstBufferType' => undef,
    'CliFilterPlugins' => undef,
    'CommunicationParameters' => undef,
    'CompleteWait' => '0',
    'CoreSpecPlugin' => undef,
    'CpuFreqDef' => undef,
    'CpuFreqGovernors' => 'OnDemand,Performance,UserSpace',
    'CredType' => 'cred/munge',
    'DebugFlags' => undef,
    'DefCpuPerGPU' => undef,
    'DefMemPerCPU' => undef,
    'DefMemPerGPU' => undef,
    'DefMemPerNode' => undef,
    'DependencyParameters' => undef,
    'DisableRootJobs' => 'NO',
    'EioTimeout' => '60',
    'EnforcePartLimits' => 'NO',
    'EpilogMsgTime' => '2000',
    'FairShareDampeningFactor' => '1',
    'FederationParameters' => undef,
    'FirstJobId' => '1',
    'GetEnvTimeout' => '2',
    'GresTypes' => undef,
    'GroupUpdateForce' => '1',
    'GroupUpdateTime' => '600',
    'GpuFreqDef' => 'high,memory=high',
    'HealthCheckInterval' => '0',
    'HealthCheckNodeState' => 'ANY',
    'InactiveLimit' => '0',
    'InteractiveStepOptions' => '"--interactive --preserve-env --pty $SHELL"',
    'JobAcctGatherType' => 'jobacct_gather/cgroup',
    'JobAcctGatherFrequency' => 'task=30,energy=0,network=0,filesystem=0',
    'JobAcctGatherParams' => undef,
    'JobCompType' => undef,
    'JobContainerType' => undef,
    'JobFileAppend' => undef,
    'JobRequeue' => '1',
    'JobSubmitPlugins' => undef,
    'KeepAliveTime' => undef,
    'KillOnBadExit' => '0',
    'KillWait' => '30',
    'NodeFeaturesPlugins' => undef,
    'LaunchParameters' => undef,
    'LaunchType' => 'launch/slurm',
    'Licenses' => undef,
    'LogTimeFormat' => 'iso8601_ms',
    'MailDomain' => undef,
    'MailProg' => '/bin/mail',
    'MaxArraySize' => '1001',
    'MaxDBDMsgs' => '10000',
    'MaxJobCount' => '10000',
    'MaxJobId' => '67043328',
    'MaxMemPerCPU' => undef,
    'MaxMemPerNode' => undef,
    'MaxStepCount' => '40000',
    'MaxTasksPerNode' => '512',
    'MCSParameters' => undef,
    'MCSPlugin' => 'mcs/none',
    'MessageTimeout' => '10',
    'MinJobAge' => '300',
    'MpiDefault' => 'none',
    'MpiParams' => undef,
    'OverTimeLimit' => '0',
    'PluginDir' => '/usr/lib64/slurm',
    'PowerParameters' => undef,
    'PowerPlugin' => undef,
    'PreemptMode' => 'OFF',
    'PreemptType' => 'preempt/none',
    'PreemptExemptTime' => undef,
    'PriorityCalcPeriod' => '5',
    'PriorityDecayHalfLife' => '7-0',
    'PriorityFavorSmall' => 'NO',
    'PriorityFlags' => undef,
    'PriorityMaxAge' => '7-0',
    'PriorityParameters' => undef,
    'PrioritySiteFactorParameters' => undef,
    'PrioritySiteFactorPlugin' => 'site_factor/none',
    'PriorityType' => 'priority/multifactor',
    'PriorityUsageResetPeriod' => 'NONE',
    'PriorityWeightAge' => '0',
    'PriorityWeightAssoc' => '0',
    'PriorityWeightFairshare' => '0',
    'PriorityWeightJobSize' => '0',
    'PriorityWeightPartition' => '0',
    'PriorityWeightQOS' => '0',
    'PriorityWeightTRES' => undef,
    'PrivateData' => undef,
    'ProctrackType' => 'proctrack/cgroup',
    'PrologEpilogTimeout' => undef,
    'PrologFlags' => undef,
    'PropagatePrioProcess' => '0',
    'PropagateResourceLimits' => 'ALL',
    'PropagateResourceLimitsExcept' => undef,
    'RebootProgram' => undef,
    'ReconfigFlags' => undef,
    'RequeueExit' => undef,
    'RequeueExitHold' => undef,
    'ResumeFailProgram' => undef,
    'ResumeProgram' => undef,
    'ResumeRate' => '300',
    'ResumeTimeout' => '60',
    'ResvOverRun' => '0',
    'ReturnToService' => '0',
    'RoutePlugin' => 'route/default',
    'SchedulerParameters' => undef,
    'SchedulerTimeSlice' => '30',
    'SchedulerType' => 'sched/backfill',
    'ScronParameters' => undef,
    'SelectType' => 'select/cons_tres',
    'SelectTypeParameters' => undef,
    'SlurmctldAddr' => undef,
    'SlurmctldDebug' => 'info',
    'SlurmctldParameters' => undef,
    'SlurmctldPlugstack' => undef,
    'SlurmctldPidFile' => '/var/run/slurmctld.pid',
    'SlurmctldPrimaryOffProg' => undef,
    'SlurmctldPrimaryOnProg' => undef,
    'SlurmctldSyslogDebug' => 'info',
    'SlurmctldTimeout' => '120',
    'SlurmdDebug' => 'info',
    'SlurmdParameters' => undef,
    'SlurmdPidFile' => '/var/run/slurmd.pid',
    'SlurmdSyslogDebug' => 'info',
    'SlurmdTimeout' => '300',
    'SlurmSchedLogLevel' => '0',
    'SrunPortRange' => undef,
    'SuspendExcNodes' => undef,
    'SuspendExcParts' => undef,
    'SuspendProgram' => undef,
    'SuspendRate' => '60',
    'SuspendTime' => '-1',
    'SuspendTimeout' => '30',
    'SwitchType' => undef,
    'TaskPlugin' => 'task/affinity,task/cgroup',
    'TaskPluginParam' => undef,
    'TCPTimeout' => '2',
    'TmpFS' => '/tmp',
    'TopologyParam' => undef,
    'TopologyPlugin'  => undef,
    'TrackWCKey' => undef,
    'TreeWidth' => '16',
    'UnkillableStepProgram' => undef,
    'UnkillableStepTimeout' => '60',
    'UsePAM' => '0',
    'VSizeFactor' => '0',
    'WaitTime' => '0',
    'X11Parameters' => undef,
  }

  $slurmdbd_conf_defaults = {
    'ArchiveEvents' => 'no',
    'ArchiveJobs' => 'no',
    'ArchiveResvs' => 'no',
    'ArchiveScript' => undef,
    'ArchiveSteps' => 'no',
    'ArchiveSuspend' => 'no',
    'ArchiveTXN' => 'no',
    'ArchiveUsage' => 'no',
    'AuthAltTypes' => undef,
    'AuthAltParameters' => undef,
    'AuthType' => 'auth/munge',
    'CommitDelay' => undef,
    'CommunicationParameters' => undef,
    'DbdBackupHost' => undef,
    'DbdAddr' => undef,
    'DebugFlags' => undef,
    'DebugLevel' => 'info',
    'DebugLevelSyslog' => 'info',
    'DefaultQOS' => undef,
    'LogTimeFormat' => 'iso8601_ms',
    'MaxQueryTimeRange' => 'INFINITE',
    'MessageTimeout' => '10',
    'Parameters' => undef,
    'PidFile' => '/var/run/slurmdbd.pid',
    'PluginDir' => '/usr/lib64/slurm',
    'PrivateData' => undef,
    'PurgeEventAfter' => undef,
    'PurgeJobAfter' => undef,
    'PurgeResvAfter' => undef,
    'PurgeStepAfter' => undef,
    'PurgeSuspendAfter' => undef,
    'PurgeTXNAfter' => undef,
    'PurgeUsageAfter' => undef,
    'StorageBackupHost' => undef,
    'StorageParameters' => undef,
    'TCPTimeout' => '2',
    'TrackSlurmctldDown' => 'no',
    'TrackWCKey' => undef,
  }
}
